/*
* Return value of time() library function.
* Same functionality as TclX function by the same name.
* (Can't call it "time" since Tcl defines that already.)
*/
#include <time.h>
#include <tcl.h>


int Tcl_getclock(ClientData client, Tcl_Interp *interp, int argc, char **argv)
{
  if (argc != 1) {
    Tcl_AppendResult (interp, "wrong # args", argv[0], (char *) NULL);
    return TCL_ERROR;
  }
  sprintf (interp->result, "%ld", time ((time_t *) NULL));
  return TCL_OK;
}
