#include <sys/types.h>
#include <sys/socket.h>      /* struct sockaddr */
#include <netdb.h>           /* gethostbyname() */
#include <netinet/in.h>      /* sockaddr_in */
#include <arpa/inet.h>       /* inet_addr() */
#include <rpcsvc/ypclnt.h>   /* YP */
#include <stdio.h>

/*
* Return IP address given host name 'host'.
*/
char* host2ip(char *host)
{
  register struct hostent *hep;
  /* Check whether this is a dotted decimal. */
  if ( inet_addr(host) != -1) {
    return host;
  }
  /* Attempt to resolve host name via DNS. */
  if ((hep = gethostbyname(host))) {
    return inet_ntoa(*(struct in_addr *)(hep->h_addr_list[0]));
  }
  return NULL;
} /* host2ip */
        

#include <tcl.h>
int Tcl_host2ip(ClientData client, Tcl_Interp *interp, int argc, char *argv[]
)
{
  char* result;

  if (argc != 2) {
    sprintf(interp->result, "%s: illegal # of args (%d)", argv[0], argc);
    return TCL_ERROR;
  }

 result= host2ip(argv[1]);
  
  if (result != NULL) {
    sprintf(interp->result, "%s", result);
  } else {
    sprintf(interp->result, "error");
  }

  return TCL_OK;
} /* Tcl_host2ip */

