#
# Start applications based on entries in mailcap file (RFC 1524). 
# Return mailcap "id=" identifier or "".  NOTE: Applications in
# mailcap file should use %s as argument.  Uses 'interactive'
# application (if defined) to avoid conflicts with MIME viewers for
# the same type (e.g., video/jpeg and video/mpeg).  If not defined,
# use viewer.  Passes destination address, port, TTL, confid, media
# using %{} mechanism.  Uses mailcap.tcl library.
#
mailcap_load

proc application {ct} {
    
    set ct [mailcap_parse_content_type $ct p]
    
    set cmd [mailcap_getrule $ct p "interactive" attrib ""]
    if {[info exists attrib(id)]} {
	footer "Trying to start $cmd for $ct (version $attrib(id))"
    } else {
	set attrib(id) ""
	footer "Trying to start $cmd for $ct"
    }
    
    # execute command
    eval exec [string trim $cmd] &;
    return $attrib(id)
}
