# list of items, in tabular display
# requires BLT
#
# $Id: blist.tcl,v 1.2 1998/07/20 16:41:26 stb Exp $
#
 
# w:      window name
# label:  label text
# lw:     label width
# height: height of list box (rows)
# slist:  list of entries to be shown (labels)
#         {{name value label_string} {name value label_string}}
# v:      variable name
proc blist {w label lw height slist v} {
  frame $w

  if {$lw < 0} {
    set lw [string length $label]
  }

  set row 0
  set col 0
  frame $w.list -relief groove -borderwidth 2
  foreach t $slist {
    set k [lindex $t 0]
    radiobutton $w.$k -relief flat -text [lindex $t 2] -variable $v \
      -value [lindex $t 1]
    grid configure  $w.$k -in $w.list -columnspan 2 -sticky w
    incr row
    if {$row == $height} {
      set row 0
      incr col
    }
  }
  pack [label $w.label -text "$label:" -width $lw -anchor nw] $w.list \
    -side left
  return $w
}
