#
# Remote control functions using TCP
#
# $Id: control_tcp.tcl,v 1.2 1998/07/20 16:41:29 stb Exp $
#
#proc control_read_tcp { mode fileId } {
#  control_eval [dp_packetReceive $fileId]
#}
proc control_read_tcp { fileId } {
  control_eval [read $fileId]
}

#
# Initialize communication with {protocol host port}
#
proc control_init_tcp {controller} {
  global cfile errorCode

  set cfile 0
  set host [lindex $controller 1]
  set port [lindex $controller 2]
  if {[catch {set c [socket $host $port]} msg]} { 
    if {[lindex $errorCode 1] == "ECONNREFUSED"} {
      tkerror "Cannot connect to pmm at $host, port $port. Make sure pmm is running"
      exit
    } else {
      tkerror "$msg"
    }
    return
  }
  
  set cfile $c
  fileevent $cfile readable "control_read_tcp $c"

  # define sending procedure
  proc control_send {msg} {
    global cfile

    puts $cfile $msg
    flush $cfile
    puts "control_send: $msg"
  }
}
