#
# sip_file.tcl
# procedures to read and save the .sipforward and .sipphonebook file
#



proc save_check {handler} {
  global image sip_handler phonebook
    
  if [subst $[subst $handler](modified)] {
    # create warning window
    set w .($handler)_warning
    if [winfo exists $w] return
    toplevel $w
    set title "Warning !"
    wm title $w $title
    frame $w.title
    pack \
      [label $w.title.im -image $image(warning) -anchor center] \
      [label $w.title.title -text $title -font *-*-*-bold-i-*-18-*-*-*-*-*-*-*] \
      -side left -anchor w
 
    frame $w.buttons
    pack \
      [button $w.buttons.s -text Save -command "destroy $w; save_$handler"] \
      [button $w.buttons.d -text Dismiss -command "destroy $w; destroy .$handler"] \
      -side left -anchor w

    pack \
      $w.title \
      [label $w.l -text "Dismiss without saving ?"] \
      $w.buttons \
      -side top 
  } else {
    destroy .$handler
  }
} ;# save_check



proc save_file {file_name lines} {
  global env 

  catch {exec rm $env(HOME)/$file_name}
  set file_handler [open ~/$file_name a+]
  foreach line $lines {
    puts $file_handler $line
  }
  close $file_handler    
} ;# save_file


proc read_file {file_name} {
  global env

  if {![file readable ~/$file_name]} {
    return ""
  }

  set file_handler [open ~/$file_name a+]
  seek $file_handler 0
  set lines [split [read $file_handler] "\n"]
  if {([llength $lines] > 0) && ([lindex $lines end] == "")} {
    set lines [lreplace $lines end end]
  } 
  close $file_handler
  return $lines
} ;#read_file
