/* Supplementary routines for pmm.tcl */ 

#include "mpoll.h"
/* #include "udp/tclUdp.h" */
/*Tcl/Tk8.0*/
#include "udp/tclUdp.h"


#define   SOCKET_BUFFER_SIZE   65536

int Tcl_SetSockBuffer_cmd(ClientData client, Tcl_Interp *interp, int argc, char *argv[])
{
  int socket;
  int size;
  int len = sizeof(int);
  
  if (argc != 2) {
    sprintf(interp->result, "%s illegal # of args (%d)", argv[0], argc);
    return TCL_ERROR;
  }
  
  socket = atoi(argv[1]+4);
  size = SOCKET_BUFFER_SIZE;   
  setsockopt(socket, SOL_SOCKET, SO_SNDBUF, (char *) &size, len);
  setsockopt(socket, SOL_SOCKET, SO_RCVBUF, (char *) &size, len);
  
  return TCL_OK;
}

pmm_init() {
  Tcl_CreateCommand(Et_Interp, "udp",
		    Tcl_UdpCmd,
		    (ClientData) NULL,
		    (Tcl_CmdDeleteProc *) NULL);
  Tcl_CreateCommand(Et_Interp, "Tcl_SetSockBuffer",
		    Tcl_SetSockBuffer_cmd,
		    (ClientData) NULL,
		    (Tcl_CmdDeleteProc *) NULL);
  
  /* HAS TO BE REPLACED BY ET_INCLUDE( pmm.tcl ) !!! */
  /*ET( source /net/fb/step/src/mint/mpoll-Beta-1.5/pmm.tcl );*/
  ET_INCLUDE( pmm.tcl );
}

ET_PROC(my_id) {
  char buf[100]; 
  sprintf(buf,"%s@%s",username,hostname);
  interp->result = buf;
  return ET_OK;
}

ET_PROC( pmmExit ) {
  writedata();
  exit(0); /* normal exit */
}
