# @(#)quest.tcl	1.5  97/12/23

# Copyright (c) Communications Research Centre, Government of Canada 1997. 
# All rights reserved.
# 
# License is granted to copy and use this software, for research and
# evaluation purposes, provided that the Communications Research Centre
# is acknowledged in all documentation pertaining to any such copy or
# use. The Communications Research Centre grants no other licenses
# expressed or implied. Title, ownership rights, and intellectual
# property rights in the software shall remain with the Communications
# Research Centre.  The Centre's name and the Government of Canada
# should not be used in any advertising without written permission.
# 
# THE COMMUNICATIONS RESEARCH CENTRE MAKES NO REPRESENTATIONS CONCERNING
# EITHER THE MERCHANTABILITY OF THIS SOFTWARE OR THE SUITABILITY OF
# THIS SOFTWARE FOR ANY PARTICULAR PURPOSE.  The software is provided
# "as is" without express or implied warranty of any kind.
# 
# These notices must be retained in any copies of any part of this
# software.
# 

# the question display window

toplevel .qmain

wm title .qmain "$summary"

label .qmain.topicnum \
   -text  "Topic: $summary" \
   -fg  "blue"
pack .qmain.topicnum -pady  2

message .qmain.question \
   -text "$question" \
   -justify  "left" \
   -width  "300"
pack .qmain.question


# create an option info frame, which will be used in the C quest() routine

frame .qmain.optionframe \
   -borderwidth 2
pack .qmain.optionframe -pady 0

# create a frame for the buttons
# the buttons themselves are created in mpoll.c:quest()

frame .qmain.butframe
pack .qmain.butframe -pady 0

frame .qmain.expireframe
pack .qmain.expireframe -pady 0


message .qmain.decay \
   -text "Response Life Time: $decaytime minutes" \
   -font "$small_font"  \
   -justify  center \
   -width  300
pack .qmain.decay 


# create a frame for the author information
frame .qmain.authorframe
pack .qmain.authorframe -side top  -fill  "x" -pady 0

# add the author info
message .qmain.authorframe.author \
   -text "Created by $author" \
   -font "$small_font"  \
   -justify center \
   -width 600
pack .qmain.authorframe.author -side top

message .qmain.authorframe.date \
   -text "On $create_time" \
   -font "$small_font"  \
   -justify center \
   -width 600
pack .qmain.authorframe.date -side top



# bottom buttons are created now

frame .qmain.bottomframe
pack .qmain.bottomframe -side "bottom"  -fill  "x" -pady 1

button .qmain.bottomframe.submit \
   -text "Submit Response" \
   -command "submit $tcltopic"
pack .qmain.bottomframe.submit -side  "left"

button .qmain.bottomframe.results \
   -text "View Results" \
   -command "viewresults $tcltopic"
pack .qmain.bottomframe.results -side  "left"  -padx 0

button .qmain.bottomframe.dismiss \
   -text "Dismiss" \
   -command {destroy .qmain}
pack .qmain.bottomframe.dismiss -side  "right"

button .qmain.bottomframe.help \
   -text  "Help" \
    -command {helpme quest}
pack .qmain.bottomframe.help -side right



