#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <errno.h>
#include <unistd.h>     /* close() */
#include <stdio.h>
#include <stdlib.h>
#include <netdb.h>

static struct sockaddr_in addr;

int 
setup_send_socket(address,port,ttl)
char *address;
int port;
unsigned char ttl;
{
    int sd,one=1;
    struct in_addr interface;
    
    bzero(&addr,sizeof(addr));
    if((sd=socket(PF_INET, SOCK_DGRAM, 0))<0){
	perror("Create Socket\n");
	return(-1);
    }
    addr.sin_family = AF_INET;
    
    if(IN_MULTICAST(htonl(inet_addr(address)))){
	addr.sin_addr.s_addr = (unsigned long)inet_addr(address);
	interface.s_addr = (unsigned long)INADDR_ANY;
	
	if (setsockopt(sd, IPPROTO_IP, IP_MULTICAST_IF,
		       (char *)&interface, sizeof(interface)) < 0) {
	    perror("IP_MULTICAST_IF");
	    return -1;
	}
	if (setsockopt(sd, SOL_SOCKET, SO_REUSEADDR, 
		       (char *)&one, sizeof(one)) < 0){
	    perror("SO_REUSEADDR");
	}
	if (setsockopt(sd, IPPROTO_IP, IP_MULTICAST_TTL,& ttl , 
		       sizeof(int)) < 0){
	  perror("Set TTL");
	}
    }
    else{
	if ((addr.sin_addr.s_addr = (unsigned long) inet_addr(address))== -1){  
	    struct hostent *host;
	    if ((host = gethostbyname(address)) == NULL) {  
		perror("Unknown host\n");
		return -1;
	    }
	    addr.sin_addr.s_addr = (unsigned long)(host->h_addr);
	}
    }

    addr.sin_port= port;
    if(bind(sd,(struct sockaddr *)&addr,sizeof(addr))<0){
	perror("Bind\n");
	return -1;
    }
    return sd;
}

int 
setup_receive_socket(address,port)
char *address;
int port;
{
    int sd,one=1;
    struct in_addr interface;
    
    bzero(&addr,sizeof(addr));
    if((sd=socket(PF_INET, SOCK_DGRAM, 0))<0){
	perror("Create Socket");
	return(-1);
    }
    addr.sin_family = AF_INET;
    
    if(IN_MULTICAST(htonl(inet_addr(address)))){
	addr.sin_addr.s_addr = (unsigned long)inet_addr(address);
	interface.s_addr = (unsigned long)INADDR_ANY;
	
	if (setsockopt(sd, IPPROTO_IP, IP_MULTICAST_IF,
		       (char *)&interface, sizeof(interface)) < 0) {
	    perror("IP_MULTICAST_IF");
	    return -1;
	}
	if (setsockopt(sd, SOL_SOCKET, SO_REUSEADDR, 
		       (char *)&one, sizeof(one)) < 0){
	    perror("SO_REUSEADDR");
	}
#ifdef	IP_ADD_MEMBERSHIP
	{
	    struct ip_mreq mreq;      /* multicast group */
	    
	    mreq.imr_multiaddr.s_addr = addr.sin_addr.s_addr;
	    mreq.imr_interface.s_addr = interface.s_addr;
	    if (setsockopt(sd, IPPROTO_IP,	IP_ADD_MEMBERSHIP, 
			   (char *)&mreq, sizeof(mreq)) < 0){
		perror("Add Membership");
		return -1;
	    }
	}
#endif
    }
    else{
	if ((addr.sin_addr.s_addr = (unsigned long) inet_addr(address))== -1){  
	    struct hostent *host;
	    if ((host = gethostbyname(address)) == NULL) {  
		perror("Unknown host");
		return -1;
	    }
	    addr.sin_addr.s_addr = (unsigned long)(host->h_addr);
	}
    }

    addr.sin_port= port;
    if(bind(sd,(struct sockaddr *)&addr,sizeof(addr))<0){
	perror("Bind Error");
	return -1;
    }
    return sd;
}


void main(int argc, char* argv[]) {
int sd;
char* buf="Hallo";
char buf1[10];
if(!strcmp(argv[1],"s")){
    sd=setup_send_socket("mint",3456,16);
    while(1){
      sendto(sd,buf,10,0,(struct sockaddr*)&addr,sizeof(addr));
	printf("%s \n",buf);
    }
}
else{
  int addrlength=sizeof(addr);
    sd=setup_receive_socket("mint",3456);
    while(1){
      recvfrom(sd,buf1,10,0,(struct sockaddr*)&addr,&addrlength);
	printf("%s \n",buf1);
    }
}
}
