int parse(int argc, char *argv[])
{
  extern char *optarg;
  extern int optind;
  char c;

  /* handle the on-line options */
  while ((c = getopt(argc, argv, "sb:h:f:R:d:C:p:Pm:a:I:q:t:")) != EOF) {
    switch(c) {
    case 's':
      session.passive = 1;
      break;
    case 'a':
      Tcl_Eval(nevit_config networks argv);
      break;
    case 'b':
      Tcl_Eval(nevit_config max_bandwidth argv);
      fprintf(stderr," argv=%s \n",argv);
      break;
    case 'P':
      Tcl_Eval(nevit_config preview argv);
      break;
    case 'h':
      message_output("Usage  nevit host/port",1);
      break;
    case 'q':
      if (session.codec.quality < 1 || session.codec.quality > 100) {
	message_output(" quality must be between 1 and 100",1);
      }
      break;
    }
  }
}
  /* handle the on-line options */
  while ((c = getopt(argc, argv, "sb:h:f:R:d:C:p:Pm:a:I:q:t:")) != EOF) {
    switch(c) {
    case 's':
      session.passive = 1;
      break;
    case 'a':
      session.net.network=atoi(optarg);
      break;
    case 'p':
      session.grabber.pb = atoi(optarg);
      break;
    case 'm':
      session.grabber.mb = atoi(optarg);
      break;
    case 'h':
      usage();
      exit(0);
      break;
    case 'q':
      session.codec.quality = atoi(optarg);
      if (session.codec.quality < 1 || session.codec.quality > 100) {
	fprintf(stderr, "quality must be between 1 and 100");
	exit(1);
      }
      break;
    case 'd':
      debug_mask(atoi(optarg));
      break;
    case 'f':
      session.grabber.frames = atoi(optarg);
      if (session.grabber.frames < 1 || 
	  session.grabber.frames > MAX_FRAME_RATE)
	fprintf(stderr, 
		"frame rate must be between 1 and %d", MAX_FRAME_RATE);
      break;
    case 'R':
      session.local->rsvp.rate=atoi(optarg);
      break;
    case 'b':
      session.grabber.bw = atoi(optarg);
      session.local->rtp_s[FIRST_LEVEL].bandwidth=atoi(argv[2]);
      break;
    case 'C':
      if (!strcasecmp(optarg, "Jpeg")) {
	JPEG_init(&session);
      } else if (!strcasecmp(optarg, "Yuv")) {
	YUV_init(&session);
      } else {
	message_output("Code Not Supported",0);
      }
      break;
    case 'I':
      session.grabber.whichinput = atoi(optarg);
      break;
    case 'P':
      session.local->preview = 1;
      break; 
    case 't':
      ttl=atoi(optarg);
      break;
    }
  }
  
