#ifndef  VIDEO_ATM_H
#define  VIDEO_ATM_H

#include "types.h"
#include "rtp.h"
#include "nevit.h"

#define PEAK_BANDWIDTH_MINIMUM 1
#define PEAK_BANDWIDTH_TARGET  2
#define MEAN_BANDWIDTH_MINIMUM 3
#define MEAN_BANDWIDTH_TARGET  4
#define MEAN_BURST_MINIMUM     5
#define MEAN_BURST_TARGET      6
#define DEVICE                 7


typedef struct {
  session_t *session;        /* pointer to session structure */
  session_r *session_rec;   /* pointer to session structure */
  int sock[NUM_PROTOCOLS];
  struct sockaddr_in serv_addr[NUM_PROTOCOLS];
  void (*proto_handler[NUM_PROTOCOLS])();
#ifdef NEW
  int sock_handler[NUM_PROTOCOLS];
#else
  Tcl_File sock_handler[NUM_PROTOCOLS];
#endif
} atm_t;

/* transmit_atm.c */
#ifdef ATM
extern ATM_init(session_t *session);
extern ATM_qos_init(int tag, char *parameter);
#endif

#endif

