#ifndef _Audio_sp_h
#define _Audio_sp_h
/* descriptor of session */
typedef enum {P_UDP, P_TCP, P_STII} net_proto_t;
typedef enum {R_vat = 0, R_rtp = 2, R_max}  rt_proto_t;

typedef struct {
  /* network */
  net_proto_t net_proto;       /* network protocol */
  rt_proto_t rt_proto;         /* outgoing real-time protocol; default inc. */ 
  u_int32 port;                /* network port */
  u_int32 confid;              /* vat confid */

  /* delay adaptation (playout delay); leave zero for default */
  struct delay_t {
    double min;                         /* minimum delay, seconds */
    double max;                         /* maximum delay, seconds */
    double initial;                     /* initial delay, seconds */
    double multiplier;                  /* variance multiplier */
    double dvar_x, dvar_y;              /* variance smoothing factors */
    int late_ts:1;                      /* late = talkspurt */
    int immediate:1;                    /* play immediately */
  } delay;

} Audio_sp_t;
#endif
