/*
 * stats.h -- statistics
 * $Id: stats.h,v 1.1.1.1 1997/11/12 17:16:33 dor Exp $
 */

typedef struct {
  u_int32 bad_header;     /* packet had a bad header (checksum, format) */
  u_int32 bad_fmt;        /* header: bad media format */
  u_int32 late;           /* packet is late */
  u_int32 lost;           /* packet was lost (never seen) */
  u_int32 dup;            /* duplicate packet */
  u_int32 misorder;       /* out of sequence */
  u_int32 samples;        /* samples received */
  u_int32 received;       /* packets received */
  u_int32 marker;         /* marked packets received */
  u_int32 control;        /* control packets received */
  u_int32 good;           /* good packets received */
  u_int32 expected;       /* expected number of packets */
  u_int32 sent;           /* packets sent by other side */
  u_int32 jitter;         /* current jitter estimate */
  u_int32 playout_delay;  /* current playout delay estimate */
  u_int32 pit;            /* packets in current talkspurt */
  /* saved from last reporting interval */
  struct {
    u_int32 expected;
    u_int32 received;
  } last;
} stats_t;
