/*
* Like standard getopt, but:
*   -long flags treated as single flag (first letter)
*   arguments must be separated by space
*   "" are skipped
*   no message on stderr
*/
#include <string.h>

/* relies on getopt() definitions */
extern int optind;
extern char *optarg;

int getoptions(const int argc, char *argv[], const char *optstring)
{
  char *f;

  while (optind < argc) {
    if (*argv[optind] == '-') {
      f = strchr(optstring, *(argv[optind]+1));
      if (f) {
        if (*(f+1) == ':') {
          optarg = argv[++optind];
        }
        optind++;
        return *f;
      }
      else {
        optind++;
        return '?';
      }
    }
    else if (*argv[optind]) {
      return -1;
    }
    optind++;
  }
  return -1;
} /* getoptions */
