/*
inet_ntoa  --  conversion of internet address to dotted quad.

Implementation of system standard inet_ntoa() function. Necessary since
gcc passes structures differently than the standard library routines
expect. For non-gcc, we use the system defined version.

Copyright 1993 by AT&T Bell Laboratories; all rights reserved
*/

#include "types.h"
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>



#if defined(__GNUC__) && defined(sun4)
char *inet_ntoa(struct in_addr in)
{
  static char a[20];

  sprintf(a, "%d.%d.%d.%d",
    in.S_un.S_un_b.s_b1,
    in.S_un.S_un_b.s_b2,
    in.S_un.S_un_b.s_b3,
    in.S_un.S_un_b.s_b4);
  return a;
} /* inet_ntoa */
#endif


/*
Same as above, but expects unsigned long as argument. 
*/
char *inet_Ntoa(u_int32 n)
{
  struct in_addr ia;
  ia.s_addr = n;
  return inet_ntoa(ia);
} /* inet_Ntoa */
