/*
 * Set socket buffer to 64K
 */

/* $ID$ */

#include "tcl.h"
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>

#define   SOCKET_BUFFER_SIZE   65536

int Tcl_SetSockBuffer_cmd(ClientData client, Tcl_Interp *interp, int argc, char *argv[])
{
  int socket;
  int size;
  int len = sizeof(int);
  
  if (argc != 2) {
    sprintf(interp->result, "%s illegal # of args (%d)", argv[0], argc);
    return TCL_ERROR;
  }

  socket = atoi(argv[1]+4);
  size = SOCKET_BUFFER_SIZE;   
  setsockopt(socket, SOL_SOCKET, SO_SNDBUF, (char *) &size, len);
  setsockopt(socket, SOL_SOCKET, SO_RCVBUF, (char *) &size, len);
  
  return TCL_OK;
}/* Tcl_SetSockBuffer_cmd */

