/*
control  --  messages to/from conference controller

Send and receive messages from conference controller.

Copyright 1994 by GMD; all rights reserved
*/

#include <stdarg.h>
#include <tcl.h>
#include <ansi.h>



/*
* Send a control message through the control channel. The message
* must be zero-terminated or otherwise dp_receiveFrom produces
* 'error 0'.
*/
void tcl(Tcl_Interp *interp, char *fmt, ...)
{
  va_list args;
  char buffer[512];

  va_start(args, fmt);
  vsprintf(buffer, fmt, args);
  va_end(args);

  if (Tcl_Eval(interp, buffer) != TCL_OK) {
    Tcl_VarEval(interp, "error {", interp->result, "}", NULL);
  }
} /* tcl */
