# Initialize and send messages to conferencing system.
# If first choice fails, fall back to tcp.
#
proc control_init {controller} {
  global prog_name debug
 
  if {[lsearch $debug pmm] >= 0} {puts "$prog_name: $controller"}
    control_init_udp $controller
 # if [catch {control_init_[lindex $controller 0] $controller} msg] {
 #   puts stderr "Error in control_init: $msg"
 #   control_init_tcp "tcp localhost [lindex $controller 2]" 
 # }
}



proc control_eval {msg} {
    global record play monitor isc_active_flag
    switch [lindex $msg 0] {
	"exit" {
	    exec rm /var/tmp/pmm_audioctl.pid
	    exit
	}
	"active" {
	    set isc_active_flag [lindex $msg 1]
	}
	"set" {
	    set tag [lindex $msg 1]
	    set value [lindex $msg 2]
	    switch $tag {
		"record(port)" {
		    switch $value {
			"+" {
			    rec_port_handler
			}
			default {
			    set $tag $value
			}
		    }
		}
		"play(port)" {
		    switch $value {
			"+" {
			    play_port_handler
			}
			default {
			    set play(port) $value
			}
		    }
		}
		"monitor(gain)" -
		"record(gain)" -
		"play(gain)" {
		    set $tag $value
		}
	    }
	}
    }
}


proc check_isc_activity {} {
    global isc_active_flag

    if {$isc_active_flag >= 1} {
	after [expr $isc_active_flag + 1000 ] check_isc_activity
	set isc_active_flag 0
    } else {
	puts here
	exec rm /var/tmp/pmm_audioctl.pid
	exit 
    }
}





