
static const char rcsid[] =
    "@(#) $Header: main.cc";

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <errno.h>
#include <signal.h>
#include <string.h>
#include <ctype.h>

#include <sys/param.h>
#include <netinet/in.h>
#include <netdb.h>
#include <sys/file.h>
#include <sys/utsname.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>


extern "C" {
#include <tk.h>
}

#include "Tcl.h"

#ifndef SIGARGS
#ifdef __SUNPRO_CC
#define SIGARGS int arg
#else
#define SIGARGS ... 
#endif
#endif


// define global debug variable
int debug;
void adios()
{
	Tcl& tcl = Tcl::instance();
      	tcl.evalc("adios_exit");
	exit(0);
}

static SIGRET 
ciao(SIGARGS)
{
	adios();
}


static class AdiosCommand : public TclObject {
public:
	AdiosCommand() : TclObject("adios") {}
	int command(int argc, const char*const* argv) {
		adios();
		/* NOT REACHED */
		return (0);
	}
} cmd_adios;



extern "C" int Udp_Init(Tcl_Interp*);
extern "C" int Tcl_idstring(ClientData, Tcl_Interp*, int ac, char** av);
extern "C" int Tcl_host2ip(ClientData, Tcl_Interp*, int ac, char** av);
extern "C" int Tcl_SetSockBuffer_cmd(ClientData, Tcl_Interp*, int ac, char **av);


int main(int argc, const char** argv)
{
  char command[100];

  extern char *optarg;
  extern int optind;
  char c;

  optind=1;
#ifdef SIGHUP
  signal(SIGHUP, ciao);
#endif
  signal(SIGPIPE, ciao);
  signal(SIGINT, ciao);
  signal(SIGTERM, ciao);
  
  Tcl::init(argc,argv,"pmm-rsvp");
  Tcl& tcl = Tcl::instance();
  Tk_Window tk = 0;
  (void) Udp_Init(tcl.interp());
  if (Tixsam_Init(tcl.interp()) == TCL_ERROR) {
    return TCL_ERROR;
  }
  tcl.CreateCommand("host2ip", Tcl_host2ip, (ClientData)0);
  tcl.CreateCommand("idstring", Tcl_idstring, (ClientData)0);
  tcl.CreateCommand("Tcl_SetSockBuffer", Tcl_SetSockBuffer_cmd, (ClientData)0);
  
  EmbeddedTcl::init();
  
  // initialize debug to 0
  debug=0;
  sprintf(command,"pmm_init ");
  while ((c = getopt(argc, argv, "SDH")) != EOF) {
    switch(c) {
    case 'S':
      sprintf(command,"pmm_init _sm");
      break;
    case 'D':
      sprintf(command,"pmm_init \"\" 1 ");
      debug=1;
      break;
    case 'H':
	fprintf(stderr," Usage: pmm-rsvp [-S standalone] [-D debug mode] [-H help] \n"); 
	exit(1);
      break;

    default:
       fprintf(stderr," Usage: pmm-rsvp -S [stand alone moe] -D [debug mode] -H [this message] \n using default mode -mint integrated \n");
     
    }
  }
  tcl.evalc(command);
#ifdef noyet
  while (tk_NumMainWindows > 0) {
    /*
     * Tk doesn't give priority to the X server so file handlers
     * (i.e., packets from the network) can starve the window
     * system (technically, tk lets one X event through per file
     * event, but a file event can trigger more than one X event
     * so the X server loses to a high-rate video source).
     * The solution is to let the X server go first by only
     * processing file handlers when their are no pending
     * X events.
     */
    if (Tk_DoOneEvent(TK_X_EVENTS|TK_IDLE_EVENTS|
		      TK_DONT_WAIT) == 0)
      Tk_DoOneEvent(0);
  }
#else
  Tk_MainLoop();
#endif
  adios();
  return (0);
}
